//Written by JavaMaker
//ChangeDialog.java
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class LinkListDialog extends JDialog
	implements ActionListener
{
	//TODO: ̈ʒuɕϐ̐錾Ă
	private Object[] objs;
	private int[] linkList;
	private LinkListModel model;
	private JList list;
	private JButton btnUp, btnDown, btnOk, btnCancel;
	private boolean isChange = false;
	
	public LinkListDialog(Frame parent) {
		super(parent,true);
		initComponents();
		setLocationRelativeTo(parent);
	}
	private void initComponents() {
		//傫ݒ肵܂
		setSize(400, 300);
		//R|[lgǉĉ;
		getContentPane().setLayout(new BorderLayout());
		model = new LinkListModel();
		list = new JList(model);
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		list.setSelectedIndex(0);
		getContentPane().add(new JScrollPane(list), BorderLayout.CENTER);
		getContentPane().add(createSouth(),BorderLayout.SOUTH);
		getContentPane().add(createEast(),BorderLayout.EAST);
		
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				
			}
		});
	}
	private JComponent createEast(){
		JPanel p = new JPanel();
		p.setLayout(new GridLayout(2,1));
		
		btnUp = new JButton("");
		btnUp.addActionListener(this);
		p.add(btnUp);
		
		btnDown = new JButton("");
		btnDown.addActionListener(this);
		p.add(btnDown);
		
		return p;
	}
	private JComponent createSouth(){
		JPanel p = new JPanel();
		p.setLayout(new GridLayout(1, 2));
		
		btnOk = new JButton("Kp");
		btnOk.addActionListener(this);
		p.add(btnOk);
		
		btnCancel = new JButton("LZ");
		btnCancel.addActionListener(this);
		p.add(btnCancel);
		
		return p;
	}
	public void setCellRenderer(ListCellRenderer renderer){
		list.setCellRenderer(renderer);
	}
	public void setListData(Object[] objs){
		this.objs = objs;
		linkList = new int[objs.length];
		
		for(int i=0;i<objs.length;i++){
			linkList[i] = i;
		}
		model.update();
	}
	public int[] getLinkList(){
		return linkList;
	}
	public boolean isChange(){
		return isChange;
	}
	public void actionPerformed(ActionEvent e){
		Object obj = e.getSource();
		if(obj == btnOk){
			onBtnOk();
		}else if(obj == btnCancel){
			onBtnCancel();
		}else if(obj == btnUp){
			onBtnUp();
		}else if(obj == btnDown){
			onBtnDown();
		}
		repaint();
	}
	private void onBtnOk(){
		
		isChange = true;
		setVisible(false);
	}
	private void onBtnCancel(){
		
		isChange = false;
		setVisible(false);
	}
	private void onBtnUp(){
		int index = list.getSelectedIndex();
		if(index >= 1){
			int temp = linkList[index];
			linkList[index] = linkList[index-1];
			linkList[index-1] = temp;
			model.change(index-1,index);
			list.setSelectedIndex(index-1);
			repaint();
		}
	}
	private void onBtnDown(){
		int index = list.getSelectedIndex();
		if(index < model.getSize() -1 ){
			int temp = linkList[index];
			linkList[index] = linkList[index+1];
			linkList[index+1] = temp;
			model.change(index,index+1);
			list.setSelectedIndex(index+1);
			repaint();
		}
	}
	private class LinkListModel extends AbstractListModel
	{
		private int lastLength = 0;
		
		public Object getElementAt(int index){
			if(objs == null){
				return null;
			}else{
				return objs[linkList[index]];
			}
		}
		public int getSize(){
			if(objs == null){
				return 0;
			}else{
				return objs.length;
			}
		}
		public void update(){
			fireContentsChanged(this, 0, Math.max(objs.length, lastLength) );
			lastLength = objs.length;
		}
		public void change(int index1, int index2){
			fireContentsChanged(this, index1, index2);
		}
	}
}
