//Written by JavaMaker
//Plime.java
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class Plime extends JFrame
	implements ActionListener
{
	//TODO: ̈ʒuɕϐ̐錾Ă
	private MainPanel panel;
	
	private JMenuItem itemOpen,itemSave,itemExit;
	private JMenuItem itemMemory,itemGC;
	private JMenuItem itemMetal,itemMotif,itemWin;
	
	public Plime(){
		initComponents();
		setVisible(true);
	}
	//-------R|[lg̏@-------------//
	private void initComponents() {
		//TODO: ɏ̏Ă
		setTitle("Plime ver. 1.02");
		
		//傫ݒ肵܂
		int width = 500;
		int height = 400;
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		setBounds(d.width/2 - width/2, d.height/2 - height/2,width,height);
		
		//e[}̎w
		PlimeTheme theme = new PlimeTheme();
		theme.setTheme();
		
		//TODO: R|[lgǉĉ;
		getContentPane().setLayout(new BorderLayout());
		panel = new MainPanel(this);
		addKeyListener(panel);
		getContentPane().add(new JScrollPane(panel), BorderLayout.CENTER);
		
		JMenuBar bar = new JMenuBar();
		bar.add(createMenuFile());
		bar.add(panel.createMenuImage());
		bar.add(panel.createMenuEdit());
		bar.add(panel.createMenuCompose());
		bar.add(createMenuLAF());
		bar.add(createMenuOption());
		getContentPane().add(bar, BorderLayout.NORTH);
		
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
	private JMenu createMenuFile(){
		//JMenu menu = new JMenu("t@C(F)");
		JMenu menu = new JMenu("t@C");
		//menu.setMnemonic('F');
		
		//itemOpen = new JMenuItem("ԕ(O)");
		itemOpen = new JMenuItem("ԕ");
		//itemOpen.setMnemonic('O');
		itemOpen.addActionListener(this);
		itemOpen.setToolTipText("ߋ̏Ԃ𕜌܂");
		itemOpen.setEnabled(false);
		menu.add(itemOpen);
		
		//itemSave = new JMenuItem("ԕۑ(S)");
		itemSave = new JMenuItem("ԕۑ");
		//itemSave.setMnemonic('S');
		itemSave.addActionListener(this);
		itemSave.setToolTipText("݂̏Ԃۑ܂");
		itemSave.setEnabled(false);
		menu.add(itemSave);
		
		menu.addSeparator();
		
		//itemExit = new JMenuItem("I(X)");
		itemExit = new JMenuItem("I");
		//itemExit.setMnemonic('X');
		itemExit.addActionListener(this);
		itemExit.setToolTipText("PlimeI܂");
		menu.add(itemExit);
		
		return menu;
	}
	private JMenu createMenuLAF(){
		JMenu menu = new JMenu("LookAndFeel");
		//menu.setMnemonic('L');
		
		itemMetal = new JMenuItem("Metal");
		//itemMetal.setMnemonic('E');
		itemMetal.setActionCommand("javax.swing.plaf.metal.MetalLookAndFeel");
		itemMetal.setEnabled(isAvailableLookAndFeel(itemMetal.getActionCommand()));
		itemMetal.addActionListener(this);
		menu.add(itemMetal);
		
		itemMotif = new JMenuItem("Motif");
		//itemMotif.setMnemonic('O');
		itemMotif.setActionCommand("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
		itemMotif.setEnabled(isAvailableLookAndFeel(itemMotif.getActionCommand()));
		itemMotif.addActionListener(this);
		menu.add(itemMotif);
		
		itemWin = new JMenuItem("Windows");
		//itemWin.setMnemonic('W');
		itemWin.setActionCommand("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		itemWin.setEnabled(isAvailableLookAndFeel(itemWin.getActionCommand()));
		itemWin.addActionListener(this);
		menu.add(itemWin);
		
		LookAndFeel[] lafs = UIManager.getAuxiliaryLookAndFeels();
		if(lafs != null){
			for(int i=0;i<lafs.length;i++){
				System.out.println(lafs[i]);
			}
		}
		return menu;
	}
	private boolean isAvailableLookAndFeel(String laf) {
		try { 
			Class lnfClass = Class.forName(laf);
			LookAndFeel newLAF = (LookAndFeel)(lnfClass.newInstance());
			return newLAF.isSupportedLookAndFeel();
		} catch(Exception e) { // If ANYTHING weird happens, return false
			return false;
		}
	}
	private void changeLAF(String InfName) {
		try {
			UIManager.setLookAndFeel(InfName);
			SwingUtilities.updateComponentTreeUI(this);
		} catch (Exception e) {}
	}
	private JMenu createMenuOption(){
		//JMenu menu = new JMenu("ݒ(O)");
		JMenu menu = new JMenu("IvV");
		//menu.setMnemonic('O');
		
		//itemMemory = new JMenuItem("Java(M)");
		itemMemory = new JMenuItem("Java");
		//itemMemory.setMnemonic('M');
		itemMemory.addActionListener(this);
		menu.add(itemMemory);
		
		//itemGC = new JMenuItem("Javȃ|(G)");
		itemGC = new JMenuItem("Javȃ|");
		//itemGC.setMnemonic('G');
		itemGC.addActionListener(this);
		menu.add(itemGC);
		
		return menu;
	}
	//-------R|[lg̏@܂-------------//
	
	public void actionPerformed(ActionEvent e) {
		//JButton,JTextField,JMenuItemȂǂɊւ鏈Ă
		Object obj = e.getSource();
		
		if(obj == itemExit){
			System.exit(0);
		}if(obj == itemMetal){
			changeLAF(itemMetal.getActionCommand());
		}else if(obj == itemMotif){
			changeLAF(itemMotif.getActionCommand());
		}else if(obj == itemWin){
			changeLAF(itemWin.getActionCommand());
		}else if(obj == itemGC){
			System.runFinalization();
			System.gc();
		}else if(obj == itemMemory){
			long total = Runtime.getRuntime().totalMemory() >> 10;
			long free = Runtime.getRuntime().freeMemory() >> 10;
			String msg = "" + (total-free) + "/" + total + " kB [gp/S]";
			JOptionPane.showMessageDialog(this,msg,"Java",JOptionPane.INFORMATION_MESSAGE);
		}
		repaint();
	}
	public static void main(String args[]) {
		Plime app = new Plime();
	}

}
