/**
* suffix̎
* 
* font
* background
* foreground
* border
* margin
*/

import java.awt.*;
import javax.swing.*;

public class PlimeTheme
{
	protected static final String[] labels = {"Label","TitledBorder","TabbedPane","TableHeader"};
	protected static final String[] buttons = {"Button","ToggleButton","CheckBox","RadioButton"};
	protected static final String[] menus = {"Menu","MenuBar","MenuItem","CheckBoxMenuItem","RadioButtonMenuItem"};
	protected static final String[] lists = {"ComboBox","List","Table"};
	protected static final String[] choosers = {"ColorChooser","FileChooser"};
	protected static final String[] panels = {"Panel","RootPane","Frame","Dialog","OptionPane"};
	
	private final Font sansSerif = new Font("SansSerif", Font.PLAIN, 12);
	private final Font monospaced = new Font("Monospaced", Font.PLAIN, 12);
	
	public void setTheme(){
		changeFont(labels, sansSerif);
		changeFont(buttons, sansSerif);
		changeFont(menus, sansSerif);
		changeFont(lists, sansSerif);
	}
	protected void changeFont(String[] strList, Font font){
		for(int i=0;i<strList.length;i++){
			UIManager.put(strList[i] + ".font" , font);
		}
	}
}
