package yoshi.editmenu;

import javax.swing.JMenuItem;
import java.awt.*;
import java.awt.image.*;

public abstract class EditMenuItem extends JMenuItem
{
	public EditMenuItem(String value){
		super(value);
	}
	/**
	* Ԃlnull̏ꍇALZ
	*/
	public abstract BufferedImage editImage(Frame parent,BufferedImage img,Rectangle rect);
	
	protected BufferedImage createBufferedImage(int[] pixel,int width,int height,boolean useAlpha,Point p){
		int rmask = 0x00FF0000;
		int gmask = 0x0000FF00;
		int bmask = 0x000000FF;
		int amask = 0;
		if(useAlpha){
			amask = 0xFF000000;
			WritableRaster r = Raster.createWritableRaster(
				new SinglePixelPackedSampleModel(DataBuffer.TYPE_INT,width,height,new int[]{rmask,gmask,bmask,amask})
				,new DataBufferInt(pixel,pixel.length),p);
			return new BufferedImage(new DirectColorModel(32,rmask,gmask,bmask,amask),r,false,null);
		}else{
			WritableRaster r = Raster.createWritableRaster
				(new SinglePixelPackedSampleModel(DataBuffer.TYPE_INT,width,height,new int[]{rmask,gmask,bmask})
				,new DataBufferInt(pixel,pixel.length),p);
			return new BufferedImage(new DirectColorModel(32,rmask,gmask,bmask),r,false,null);
		}
	}
}
