package yoshi.editmenu;

import java.awt.*;
import java.awt.image.*;

public class Reverce extends EditMenuItem
{
	public Reverce(String name){
		super(name);
	}
	public BufferedImage editImage(Frame parent,BufferedImage img,Rectangle rect){
		int[] pixel = img.getRGB(0,0,img.getWidth(),img.getHeight(),null,0,img.getWidth());
		reverce(pixel);
		return createBufferedImage(pixel,img.getWidth(),img.getHeight(),true,null);
	}
	private void reverce(int[] pixel){
		for(int i=0;i<pixel.length;i++){
			pixel[i] = (pixel[i] ^ 0x00FFFFFF);
		}
	}
}