package yoshi.editmenu.alpha;

import java.awt.*;
import java.awt.image.*;

import yoshi.editmenu.EditMenuItem;

public class Alpha extends EditMenuItem
{
	private Frame parent = null;
	private SliderDialog dialog;
	
	public Alpha(String name){
		super(name);
	}
	public BufferedImage editImage(Frame parent,BufferedImage img,Rectangle rect){
		int[] pixel = img.getRGB(0,0,img.getWidth(),img.getHeight(),null,0,img.getWidth());
		if(parent == null || this.parent != parent){
			dialog = new SliderDialog(parent,"At@l̓","At@l͂Ă");
			this.parent = parent;
		}
		dialog.setVisible(true);
		if(dialog.isSelected()){
			alpha(pixel,dialog.getValue());
			return createBufferedImage(pixel,img.getWidth(),img.getHeight(),true,null);
		}else{
			return null;
		}
	}
	/*
	* keyRGBƈvsNZ̓ߒlω܂
	*/
	private void alpha(int[] pixel,int alpha){
		alpha = (alpha << 24) & 0xFF000000;
		
		for(int i=0;i<pixel.length;i++){
			pixel[i] = (pixel[i] & 0x00FFFFFF) | alpha;
		}
	}
}