package yoshi.editmenu.decrease;

import java.util.*;

/**
* ColorPack
*/
public class ColorPack
	implements Comparable
{
	protected static int compareMode = 0;
	
	private int[] RGB = new int[3];
	private int color;
	private int number;
	
	private int[] intForCompare = new int[3];
	
	public ColorPack(int color,int number){
		//F̐ݒ
		this.color = color;
		RGB[0] = (color >> 16) & 0x00FF;
		RGB[1] = (color >> 8) & 0x00FF;
		RGB[2] =  color & 0x00FF;
		
		//\[gp̐F̍쐬
		intForCompare[0] = color;
		//intForCompare[0]  = RGB[0] << 16;
		//intForCompare[0] += RGB[1] << 8;
		//intForCompare[0] += RGB[2];
		intForCompare[1]  = RGB[1] << 16;
		intForCompare[1] += RGB[2] << 8;
		intForCompare[1] += RGB[0];
		
		intForCompare[2]  = RGB[2] << 16;
		intForCompare[2] += RGB[0] << 8;
		intForCompare[2] += RGB[1];
		this.number = number;
	}
	/**
	* FԂ܂
	*/
	public int getNumber(){
		return number;
	}
	/**
	* Fǉ܂
	*/
	public void addNumber(int n){
		number += n;
	}
	public void addNumber(){
		number++;
	}
	/**
	* FԂ܂B
	*/
	public int getRGB(){
		return color;
	}
	/**
	* ԗΐ擾܂
	* ꂼ0,1,2łB
	* ёւɎg܂
	*/
	public int getRGB(int n){
		return RGB[n];
	}
	public int[] getRGBs(){
		return RGB;
	}
	/**
	* 傫(1)(-1)(0)𔻒f܂
	*/
	public int compareTo(ColorPack c){
		int n1 = getForCompare();
		int n2 = c.getForCompare();
		if(n1 > n2){
			return 1;
		}else if(n1 < n2){
			return -1;
		}else{
			return 0;
		}
	}
	public int compareTo(Object o){
		return compareTo((ColorPack)o);
	}
	public boolean equals(Object o){
		if(o instanceof ColorPack){
			return equals((ColorPack)o);
		}else{
			return false;
		}
	}
	public boolean equals(ColorPack c){
		if(color == c.getRGB()){
			return true;
		}else{
			return false;
		}
	}
	public String toString(){
		String temp = Integer.toHexString(getForCompare() & 0x00FFFFFF);
		int n = temp.length();
		if(n>6){
			temp = temp.substring(n-6,n);
		}else{
			for(int i=0;i<6-n;i++){
				temp = "0" + temp;
			}
		}
		temp += " : "+String.valueOf(number);
		return temp;
	}
	/**
	* rpl̎擾
	*/
	protected int getForCompare(){
		return intForCompare[compareMode];
	}

}