/**
* 0xFFFȉɂ錸FtB^[łB
*/
package yoshi.editmenu.decrease;

import java.awt.Frame;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import java.util.*;

public class Decrease extends yoshi.editmenu.EditMenuItem
{
	private boolean isFFF = false; //0xFFFȉɕϊƂ
	private ColorPack[] packs; //FƂ̐ʂi[NX
	private int[] pixel; //摜̃sNZ
	
	private Frame parent;
	private DecreaseDialog dialog;
	
	public Decrease(String value){
		super(value);
	}
	
	public BufferedImage editImage(Frame parent,BufferedImage img,Rectangle rect){
		//IndexColorMaker maker = new IndexColorMaker();
		int width = img.getWidth();
		int height = img.getHeight();
		pixel = img.getRGB(0,0,width,height,null,0,width);
		
		//F𐔂
		//long st = System.currentTimeMillis();
		setColor(parent);
		//long et = System.currentTimeMillis();
		//System.out.println("setColor "+(et-st));
		
		//_CAO̕\
		String message;
		if(isFFF){
			message = "F4095Fȏ゠܂B";
		}else{
			message = "F" + packs.length + "FłB";
		}
		if(this.parent == null || this.parent != parent){
			dialog = new DecreaseDialog(parent);
			this.parent = parent;
		}
		dialog.setMessage(message);
		dialog.setVisible(true);
		
		//FwꂽƂ
		if(dialog.isSelected()){
			int max = dialog.getValue();
			//System.out.println(max);
			if(max < packs.length){ //w萔FƂ
				//st = System.currentTimeMillis();
				int[][] indexColor = createIndexColor(max);
				//et = System.currentTimeMillis();
				//System.out.println("createIndexColor "+(et-st));
				
				//st = System.currentTimeMillis();
				changeImage(indexColor, 3);
				//et = System.currentTimeMillis();
				//System.out.println("changeImage "+(et-st));
				
				isFFF = false;
				packs = null;
				return createBufferedImage(pixel, width, height, true, null);
			}else if(isFFF){ //4095ȉɂAmax菬ȂƂ
				isFFF = false;
				packs = null;
				return createBufferedImage(pixel, width, height, true, null);
			}
		}
		isFFF = false;
		packs = null;
		pixel = null;
		return null;
	}
	private void setColor(Frame parent){
		//F𐔂
		HashMap color = new HashMap();
		
		int n = pixel.length;
		
		pixel[0] = pixel[0] & 0x00FFFFFF;
		Integer now = new Integer(pixel[0]);
		ColorPack temp = new ColorPack(pixel[0], 1);
		int last = pixel[0];
		
		color.put(now, temp);
		
		for(int i=1;i<n;i++){
			pixel[i] = pixel[i] & 0x00FFFFFF;
			if(last == pixel[i]){
				temp.addNumber();
			}else{
				now = new Integer(pixel[i]);
				temp = (ColorPack)color.get(now);
				last = pixel[i];
				if(temp == null){
					temp = new ColorPack(pixel[i], 1);
					color.put(now, temp);
				}else{
					temp.addNumber();
				}
				if(color.size() > 0xFFF){ //F傫Ƃ
					int result = JOptionPane.showConfirmDialog(parent
						, "F4095ȏ゠܂BȈՌFĂłH( " + 100*i/n + "%)"
						, "F4095ȏ゠܂", JOptionPane.YES_NO_OPTION);
					
					if(result == JOptionPane.YES_OPTION){
						isFFF = true;
						setColorFFF(color,i+1);
					}else{
						setColorFull(color,i+1);
					}
					break;
				}
			}
		}
		packs = new ColorPack[color.size()];
		System.arraycopy(color.values().toArray(),0,packs,0,color.size());
		
		color = null;
	}
	/**
	* 摜̏܂BSFtɎg܂BdłB
	*/
	private void setColorFull(Map color, int start){
		int n = pixel.length;
		pixel[start] = pixel[start] & 0x00FFFFFF;
		Integer now = new Integer(pixel[start]);
		ColorPack temp = new ColorPack(pixel[start], 1);
		int last = pixel[start];
		
		color.put(now, temp);
		
		for(int i=start+1;i<n;i++){
			pixel[i] = pixel[i] & 0x00FFFFFF;
			if(last == pixel[i]){
				temp.addNumber();
			}else{
				now = new Integer(pixel[i]);
				temp = (ColorPack)color.get(now);
				last = pixel[i];
				if(temp == null){
					temp = new ColorPack(pixel[i], 1);
					color.put(now, temp);
				}else{
					temp.addNumber();
				}
			}
		}
	}
	/**
	* F0xFFF傫ƂAg܂B
	*/
	private void setColorFFF(Map color, int start){
		color.clear();
		
		int n = pixel.length;
		
		pixel[0] = pixel[0] & 0x00F0F0F0;
		Integer now = new Integer(pixel[0]);
		ColorPack temp = new ColorPack(pixel[0], 1);
		int last = pixel[0];
		
		color.put(now, temp);
		
		for(int i=1;i<n;i++){
			pixel[i] = pixel[i] & 0x00F0F0F0;
			if(last == pixel[i]){
				temp.addNumber();
			}else{
				now = new Integer(pixel[i]);
				temp = (ColorPack)color.get(now);
				last = pixel[i];
				if(temp == null){
					temp = new ColorPack(pixel[i], 1);
					color.put(now, temp);
				}else{
					temp.addNumber();
				}
			}
		}
	}
	/**
	* fBAJbgpāAw肳ꂽFɂ܂B
	*/
	private int[][] createIndexColor(int max){
		ColorBox[] boxs = new ColorBox[max];
		boxs[0] = new ColorBox(packs);
		int nowLength = 1;
		ColorBoxComparator comparator = new ColorBoxComparator();
		
		while(nowLength < max){
			int i;
			for(i=nowLength-1;i>=0;i--){ //傫̂K̂T
				if(boxs[i].canCut()){ //łƂ
					ColorBox temp = boxs[i].cut(); //Ă݂
					if(temp != null){ //łƂ
						boxs[nowLength] = temp; //
						nowLength++;
						Arrays.sort(boxs, 0, nowLength , comparator); //\[g
						break;
					}
				}
			}
			if(i < 0){ //łƂ낪ȂƂ
				return createRGB(boxs, nowLength);
			}
		}
		return createRGB(boxs, nowLength);
	}
	private int[][] createRGB(ColorBox[] boxs, int size){
		int[][] RGB = new int[size][3];
		int index = size-1;
		for(int i=0;i<size;i++){
			RGB[index] = boxs[i].getAverage();
			index--;
		}
		return RGB;
	}
	
	private void changeImage(int[][] index, int minLength){
		int size = index.length;
		int wh= pixel.length;
		
		int[] RGB;
		int[] indexTemp;
		minLength = 3*minLength*minLength;
		
		int length = packs.length;
		
		HashMap color = new HashMap(length);
		//Fϊe[u̍쐬
		for(int i=0;i<length;i++){
			RGB = packs[i].getRGBs();
			int len = 65536;
			int point = 0;
			
			for(int j=0;j<size;j++){
				int temp = 0;
				indexTemp = index[j];
				for(int k=0;k<3;k++){
					int sub = indexTemp[k] - RGB[k];
					temp += sub*sub;
				}
				if(len > temp){
					point = j;
					len = temp;
					if(len <= minLength) break;
				}
			}
			indexTemp = index[point];
			int p = 0xFF000000 | (indexTemp[0] << 16) | (indexTemp[1] << 8) | indexTemp[2];
			color.put(new Integer(packs[i].getRGB()), new Integer(p));
		}
		//ϊ
		int last = pixel[0];
		int convert = ((Integer)color.get(new Integer(pixel[0]))).intValue();
		pixel[0] = convert;
		
		for(int i=1;i<wh;i++){
			if(last != pixel[i]){
				last = pixel[i];
				convert = ((Integer)color.get(new Integer(pixel[i]))).intValue();
			}
			pixel[i] = convert;
		}
		
		index = null;
		RGB = null;
		indexTemp = null;
		color = null;
	}
	public void updateUI(){
		super.updateUI();
		if(dialog != null) SwingUtilities.updateComponentTreeUI(dialog);
	}
}
