package yoshi.imageio.arcivefilter;

import yoshi.imageio.arciver.ImageArciver;

import java.io.File;

public abstract class ImageArciveFilter extends javax.swing.filechooser.FileFilter
{
	public abstract boolean isSupport(File file);
	public abstract ImageArciver createImageArciver(File file);
	public abstract String[] getExtentions();
	public abstract int getFileSelectionMode();
	
	public boolean accept(File f){
		if(f.isFile()){
			return accept(f.getName());
		}else{
			return f.isDirectory();
		}
	}
	public boolean accept(String str){
		str = str.toLowerCase();
		//String str = (f.getName()).toLowerCase();
		String[] ext = getExtentions();
		for(int i=0;i<ext.length;i++){
			if(str.endsWith("."+ext[i])){
				return true;
			}
		}
		return false;
	}
	public String toString(){
		return getDescription();
	}
}
