//Written by JavaMaker
//DirArciver.java
package yoshi.imageio.arciver;

import java.io.*;
import java.util.*;

public class DirectoryArciver extends ImageArciver

{
	//TODO: ̈ʒuɕϐ̐錾Ă
	private boolean isSupported = false;
	private File[] files = null;
	private String name;
	
	public DirectoryArciver(File f) {
		name = f.getAbsolutePath();
		if(f != null && f.isDirectory()){
			//System.out.println(f);
			files = f.listFiles(new FileOnlyFilter());
			//files = f.listFiles();
			//System.out.println(files.length);
			if(files != null){
				files = sort(files);
				isSupported = true;
			}
		}
	}
	/**
	* T|[gĂ邩
	*/
	public boolean isSupported(){
		return isSupported;
	}
	/**
	* I
	*/
	public void close(){
		isSupported = false;
		files = null;
	}
	/**
	* t@C̎擾
	*/
	public int getFileCount(){
		if(files == null || files.length == 0){
			return 0;
		}else{
			return files.length;
		}
	}
	/**
	* O̎擾
	*/
	public String[] getName(){
		if(files == null || files.length == 0){
			return null;
		}else{
			String[] name = new String[files.length];
			for(int i=0;i<files.length;i++){
				//System.out.println(name);
				name[i] = files[i].getName();
			}
			return name;
		}
	}
	/**
	* ̖O̎擾
	*/
	public String getName(int n){
		if(n < 0 || n >= getFileCount()) return null;
		return files[n].getName();
	}
	/**
	* f[^̎擾ÃNXł͑傫Ƃ̂ŕԂ܂
	*/
/*	public byte[] getData(int n){
		InputStream in = getInputStream(n);
		if(in == null) return null;
		byte[] b;
		try{
			b = new byte[in.available()];
			in.read(b);
		}catch(IOException e){
			return null;
		}
		return b;
	}*/
	/**
	* InputStream̎擾
	*/
	public InputStream getInputStream(int n){
		if(n < 0 || n >= getFileCount()) return null;
		FileInputStream in;
		try{
			in = new FileInputStream(files[n]);
		}catch(FileNotFoundException e){
			return null;
		}
		return in;
	}
	public String toString(){
		return name;
	}
	private File[] sort(File[] preFile){
		if(preFile == null) return null;
		TreeSet sortTree = new TreeSet();
		for(int i=0;i<preFile.length;i++){
			sortTree.add(preFile[i]);
		}
		Object[] obj = sortTree.toArray();
		File[] reFile = new File[obj.length];
		for(int i=0;i<obj.length;i++){
			reFile[i] = (File)obj[i];
		}
		return reFile;
	}
	private class FileOnlyFilter implements FileFilter
	{
		public boolean accept(File pathname){
			return pathname.isFile();
		}
	}
}
