//Written by JavaMaker
//BMPDialog.java
package yoshi.imageio.filedialog;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class BMPDialog extends JDialog
	implements ActionListener
{
	public static final int FULLCOLOR = 24;
	public static final int INDEX256 = 8;
	public static final int INDEX16 = 4;
	public static final int INDEX2 = 1;
	
	//TODO: ̈ʒuɕϐ̐錾Ă
	private JButton ok,cancel;
	private ButtonGroup mode;
	private JCheckBox index256,index16,index2;
	private boolean isWrite = false;
	
	public BMPDialog(Frame parent) {
		super(parent,true);
		initComponents();
		setLocationRelativeTo(parent);
	}

	public boolean isWrite(){
		return isWrite;
	}
	public int getBitSize(){
		return Integer.parseInt(mode.getSelection().getActionCommand());
	}
	public void setColorNumber(int n){
		index2.setEnabled(n <= 2);
		index16.setEnabled(n <= 16);
		index256.setEnabled(n <= 256);
	}
	public void actionPerformed(ActionEvent e) {
		//JButton,JTextField,JMenuItemȂǂɊւ鏈Ă
		Object obj = e.getSource();
		if(obj == ok){
			isWrite = true;
			setVisible(false);
		}else if(obj == cancel){
			isWrite = false;
			setVisible(false);
		}
	}

	private void initComponents() {
		//TODO: ɏ̏Ă

		setTitle("BMP̃IvVݒ");
		//傫ݒ肵܂
		setSize(200,210);
		getContentPane().setLayout(new BorderLayout(2,2));
		getContentPane().add(new JLabel("BMP̃IvVݒ",JLabel.CENTER),BorderLayout.NORTH);
		getContentPane().add(createSouth(),BorderLayout.SOUTH);
		getContentPane().add(createMode(),BorderLayout.CENTER);
		//getContentPane().add(createChangeAlpha(),BorderLayout.EAST);
		
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				isWrite = false;
				setVisible(false);
			}
		});
	}
	private JPanel createSouth(){
		JPanel p = new JPanel();
		p.setLayout(new GridLayout(1,2));
		
		ok = new JButton("");
		ok.addActionListener(this);
		p.add(ok);
		
		cancel = new JButton("");
		cancel.addActionListener(this);
		p.add(cancel);
		
		return p;
	}
	private JPanel createMode(){
		JPanel p = new JPanel();
		p.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"ۑ`I"));
		p.setLayout(new BoxLayout(p,BoxLayout.Y_AXIS));
		mode = new ButtonGroup();
		
		JCheckBox full = new JCheckBox("tJ[",true);
		full.setActionCommand(String.valueOf(FULLCOLOR));
		mode.add(full);
		p.add(full);
		
		index256 = new JCheckBox("256F",false);
		index256.setActionCommand(String.valueOf(INDEX256));
		mode.add(index256);
		p.add(index256);
		
		index16 = new JCheckBox("16F",false);
		index16.setActionCommand(String.valueOf(INDEX16));
		mode.add(index16);
		p.add(index16);
		
		index2 = new JCheckBox("2F",false);
		index2.setActionCommand(String.valueOf(INDEX2));
		mode.add(index2);
		p.add(index2);
		return p;
	}
}
