package yoshi.imageio.filefilter;

import yoshi.imageio.reader.PDTReader;

import java.io.*;
import java.awt.*;
import java.awt.image.BufferedImage;

public class PDTFileFilter extends ImageFileFilter
{
	public boolean canRead(){
		return true;
	}
	public BufferedImage read(Frame parent,InputStream in) throws IOException{
		return (new PDTReader(in)).getImage();
	}
	public boolean canWrite(){
		return false;
	}
	public String[] getExtentions(){
		return new String[]{"pdt"};
	}
	public String getDescription(){
		return "PDT Image File (pdt)";
	}
}