package yoshi.editmenu.alpha;

import java.awt.*;
import java.awt.image.*;

import yoshi.editmenu.EditMenuItem;

public class Blend extends EditMenuItem
{
	private Frame parent = null;
	private SliderDialog dialog;
	
	public Blend(String name){
		super(name);
	}
	public BufferedImage editImage(Frame parent,BufferedImage img,Rectangle rect){
		int[] pixel = img.getRGB(0,0,img.getWidth(),img.getHeight(),null,0,img.getWidth());
		if(parent == null || this.parent != parent){
			dialog = new SliderDialog(parent,"At@l̓","At@l͂Ă");
			this.parent = parent;
		}
		//߃L[
		int key = pixel[0];
		if(rect != null){
			key = pixel[rect.x + rect.y*img.getWidth()];
		}
		dialog.setVisible(true);
		if(dialog.isSelected()){
			blend(pixel,dialog.getValue(),key);
			return createBufferedImage(pixel,img.getWidth(),img.getHeight(),true,null);
		}else{
			return null;
		}
	}
	/*
	* keyRGBƈvsNZ̓ߒlω܂
	*/
	public void blend(int[] pixel,int alpha,int key){
		key = key & 0x00FFFFFF;
		alpha = (alpha << 24) & 0xFF000000;
		
		for(int i=0;i<pixel.length;i++){
			int temp = pixel[i] & 0x00FFFFFF;
			if(key == temp){
				pixel[i] = temp | alpha;
			}
		}
	}
}