//Written by JavaMaker
//IndexColor.java
package yoshi.editmenu.decrease;

import java.awt.*;
import java.awt.image.*;
import java.util.*;

//import javax.swing.ProgressMonitor;

public class IndexColorMaker
	implements ImageObserver
{
	private TreeSet set;  //F̑ɂȂColorBox
	private int origin; //̐F
	private int[] pixel; //sNZ
	private int width,height; //摜̑傫
	private Map color; //SJ[e[u
	private boolean canEdit = false;
	/**
	* RXgN^łBsetImageŐݒ肵Ă
	*/
	public IndexColorMaker(){
		width = -1;
		height = -1;
		canEdit = false;
	}
	public boolean canEdit(){
		return (pixel != null);
	}
	/**
	* sNZݒ肵܂
	*/
	public void setPixel(int[] pixel,Dimension d){
		setPixel(pixel,d.width,d.height);
	}
	/**
	* sNZݒ肵܂
	*/
	public void setPixel(int[] pixel,int width,int height){
		this.pixel = pixel;
		if(pixel == null){
			canEdit = false;
		}
		this.width = width;
		this.height = height;
		//canEdit = true;
		setColor();
	}
	public int getColorNumber(){
		return origin;
	}
	/**
	* 摜ݒ肵܂
	*/
	/*public void setImage(Image img){
		if(img == null){
			canEdit = false;
			return;
		}
		width = img.getWidth(this);
		height = img.getHeight(this);
		
		if(width <= -1 || height <= -1){
			canEdit = loadImage(img);
		}else{
			canEdit = true;
		}
		if(canEdit){
			pixel = new int[width*height];
			
			PixelGrabber pg = new PixelGrabber(img,0,0,width,height,pixel,0,width);
			try {
				pg.grabPixels();
			} catch (InterruptedException e) {
				canEdit = false;
				return;
			}
		//	setColor();
		}
	}*/
	/**
	* sNZ擾܂
	* i[Ă\[X̂n邽߁BωȂ̓Rs[Ă
	*/
	public int[] getPixel(){
		return pixel;
	}
	/**
	* 摜̑傫擾܂
	*/
	/*public Dimension getSize(){
		return new Dimension(width,height);
	}*/
	/**
	* ϊ̉摜擾܂
	*/
	/*public Image getImage(){
		if(checkEdit()){
			return Toolkit.getDefaultToolkit().createImage(new MemoryImageSource(width, height, pixel, 0, width));
		}else{
			return null;
		}
	}*/
	/**
	* F܂
	*/
	public void decrease(int index){
		decrease(index,3);
	}
	/**
	* F܂
	*/
	public void decrease(int index,int minLength){
		//if(!checkEdit()) return;
		
		//setColor();
		if(origin > index){
		//	System.out.println("decrease");
			setNormalize(index,minLength);
			int[][] RGB = getIndexColor();
			changeImage(RGB,minLength);
			RGB = null;
		}else{
			pixel = null;
		}
	}
	/**
	* ϊ܂
	*/
	private void changeImage(int[][] index,int minLength){
		int size = index.length;
		int wh= pixel.length;
		
		int[] RGB = new int[3];
		int[] indexTemp;
		minLength = 3*minLength*minLength;
		
		Object[] colors = (color.keySet()).toArray();
		int length = colors.length;
		color = new HashMap(length);
	//	color = new TreeMap();
		//Fϊe[u̍쐬
		for(int i=0;i<length;i++){
			int p = ((Integer)colors[i]).intValue();
			RGB[0] = (p >> 16) & 0x00FF;
			RGB[1] = (p >> 8)  & 0x00FF;
			RGB[2] = p & 0x00FF;
			int len = 65536;
			int point = 0;
			
			for(int j=0;j<size;j++){
				int temp = 0;
				indexTemp = index[j];
				for(int k=0;k<3;k++){
					int sub = indexTemp[k] - RGB[k];
					temp += sub*sub;
				}
				if(len > temp){
					point = j;
					len = temp;
					if(len <= minLength) break;
				}
			}
			indexTemp = index[point];
			p = (255 << 24) | (indexTemp[0] << 16) | (indexTemp[1] << 8) | indexTemp[2];
			color.put((Integer)colors[i],new Integer(p));
		}
		//ϊ
		for(int i=0;i<wh;i++){
			pixel[i] = ((Integer)color.get(new Integer(pixel[i] & 0x00FFFFFF))).intValue();
		}
		
		index = null;
		RGB = null;
		indexTemp = null;
		color = null;
	}
	/**
	* Fpe[u쐬܂
	*/
	private void setNormalize(int max,int minLength){
		if(origin <= max) return;
		Object[] object;

		ColorBox c ;
		ColorBox[] temp;
		//傫őlɂȂ܂ł
		while(set.size() < max){
			int size = set.size();
			object = set.toArray();
			
			int i= size-1;
			//܂ŌJԂ
			while(true){
				c = (ColorBox)object[i];
				
				if(c.canCut()){ //łƂ
					temp = c.cut(minLength);
					if(temp != null){
						break;
					}
				}
				i--;
				if(i < 0){	//őlɒBɏIƂ
					return;
				}
			}
			set.add(temp[0]);
			set.add(temp[1]);
			set.remove(c);
		}
	}
	/**
	* intzɂ܂
	*/
	private int[][] getIndexColor(){
		int size = set.size();
		Object[] object = set.toArray();
		int[][] RGB = new int[size][3];
		int index = size-1;
		for(int i=0;i<size;i++){
			RGB[index] = ((ColorBox)object[i]).getAverage();
			index--;
		}
		return RGB;
	}
	/**
	* 摜̏܂
	*/
	private void setColor(){
		//F𐔂
	//	HashMap color = new HashMap();
		color = new HashMap();
		
		int n = pixel.length;
		
		for(int i=0;i<n;i++){
		//	pixel[i] = pixel[i] & 0x00FFFFFF;
			Integer now = new Integer(pixel[i] & 0x00FFFFFF);
			Integer temp = (Integer)color.get(now);
			if(temp == null){
				color.put(now,new Integer(1));
			}else{
				int count = temp.intValue()+1;
				color.put(now,new Integer(count));
			}
		}
		
		//ColorBox̍쐬
		int size = color.size();
		Object[] colorTemp = (color.keySet()).toArray();
		ColorPack[] colorPack = new ColorPack[size];
		
		for(int i=0;i<size;i++){
			Integer temp = (Integer)colorTemp[i];
			int number = ((Integer)color.get(temp)).intValue();
			colorPack[i] = new ColorPack(temp.intValue(),number);
		}
		ColorBox colorBox = new ColorBox(colorPack);
		
		set = new TreeSet();
		set.add(colorBox);
		
		origin = size;
	}
	private int[] ImagetoPixel(Image img){
		width = img.getWidth(null);
		height = img.getHeight(null);
		int[] pixel = new int[width*height];
		PixelGrabber pg;
		
		pg = new PixelGrabber(img,0,0,width,height,pixel,0,width);
		try {
			pg.grabPixels();
		} catch (InterruptedException e) {
		}
		return pixel;
	}
	/**
	* 摜Iɓǂݍ݂܂
	*/
	private boolean loadImage(Image img){
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		int n = 0;
		while (!toolkit.prepareImage(img,-1,-1,this)) {
			System.out.println("Now Loading...");
			try {
				Thread.currentThread().sleep(100);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			n++;
			if (n > 10) {
				return false;
			}
		}
		width = img.getWidth(this);
		height = img.getHeight(this);
		return true;
	}
	private boolean checkEdit(){
		canEdit = (pixel != null) & canEdit;
		return canEdit;
	}
	/**
	* ImageObserver̎ł
	*/
	public boolean imageUpdate(Image img, int infoflags, int x, int y, int width, int height){
		if( ((infoflags & WIDTH) != 0) && ((infoflags & HEIGHT) != 0) ){
			return true;
		}else{
			return false;
		}
	}
}
