package yoshi.editmenu.kernel;

import java.awt.Frame;
import java.awt.Rectangle;
import java.awt.image.*;

import yoshi.editmenu.EditMenuItem;

public class Average extends EditMenuItem
{
	private ConvolveOp op;
	
	public Average(String name){
		super(name);
		float n = (float)(1.0/9.0);
		Kernel kernel = new Kernel(3,3,new float[]{n,n,n,n,n,n,n,n,n});
		op = new ConvolveOp(kernel);
	}
	public BufferedImage editImage(Frame parent,BufferedImage img,Rectangle rect){
		return op.filter(img,null);
	}
}