package yoshi.editmenu.kernel;

import java.awt.*;
import java.awt.image.*;

import yoshi.editmenu.EditMenuItem;

public class Laplacian extends EditMenuItem
{
	private ConvolveOp op;
	
	public Laplacian(String name){
		super(name);
		Kernel kernel = new Kernel(3,3,new float[]{0,1,0,1,-4,1,0,1,0});
		op = new ConvolveOp(kernel);
	}
	public BufferedImage editImage(Frame parent,BufferedImage img,Rectangle rect){
		img = checkAlpha(img);
		return op.filter(img,null);
	}
	/**
	* AlphaĂƂ͂܂Ȃ
	*/
	protected BufferedImage checkAlpha(BufferedImage img){
		ColorModel model = img.getColorModel();
		if(model.getAlpha(0) == 255){ //At@ȂƂ
			return img;
		}else{
			int[] pixel = img.getRGB(0,0,img.getWidth(),img.getHeight(),null,0,img.getWidth());
			return createBufferedImage(pixel,img.getWidth(),img.getHeight(),false,null);
		}
	}
}
