package yoshi.editmenu.kernel;

import java.awt.Frame;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;
import java.awt.image.*;

import yoshi.editmenu.EditMenuItem;

public class Sharp extends EditMenuItem
{
	private ConvolveOp op;
	
	public Sharp(String name){
		super(name);
		Kernel kernel = new Kernel(3,3,new float[]{0,-1,0,-1,5,-1,0,-1,0});
		//Kernel kernel = new Kernel(3,3,
		//	new float[]{-1.0f, -1.0f, -1.0f, -1.0f, 9.0f, -1.0f, -1.0f, -1.0f, -1.0f});
		op = new ConvolveOp(kernel);
	}
	public BufferedImage editImage(Frame parent,BufferedImage img,Rectangle rect){
		return op.filter(img,null);
	}
}