//Written by JavaMaker
//DrawPanel.java
package yoshi.imageio.arcivedialog;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;

public class DrawPanel extends JPanel

{
	private BufferedImage img;
	private int width,height;
	
	public DrawPanel() {
		width = 0;
		height = 0;
		setLayout(null);
		setBackground(Color.black);
	}
	public void setImage(BufferedImage img){
		this.img = img;
		if(img != null){
			width = img.getWidth(this);
			height = img.getHeight(this);
		}else{
			width = 0;
			height = 0;
		}
		revalidate();
	}
	public BufferedImage getImage(){
		return img;
	}
	
	protected void paintComponent(Graphics g){
		g.setColor(getBackground());
		g.fillRect(0,0,getWidth(),getHeight());
		if(img != null){
			int x = (getWidth()-width)/2;
			int y = (getHeight()-height)/2;
			g.drawImage(img,x,y,this);
		}
	}
	public Dimension getPreferredSize(){
		return new Dimension(width,height);
	}
}
