package yoshi.imageio.arcivefilter;

import yoshi.imageio.arciver.*;

import java.io.*;

public class DirectoryFilter extends ImageArciveFilter
{
	public boolean isSupport(File file){
		return file.isDirectory();
	}
	public ImageArciver createImageArciver(File file){
		return new DirectoryArciver(file);
	}
	public String[] getExtentions(){
		return null;
	}
	public boolean accept(File f){
		return f.isDirectory();
	}
	public boolean accept(String str){
		return false;
	}
	public int getFileSelectionMode(){
		return javax.swing.JFileChooser.DIRECTORIES_ONLY;
	}
	public String getDescription(){
		return "fBNg";
	}
}