package yoshi.imageio.arcivefilter;

import yoshi.imageio.arciver.*;

import java.io.*;

public class ZIPArciveFilter extends ImageArciveFilter
{
	public ImageArciver createImageArciver(File file){
		return new ZIPArciver(file);
	}
	public boolean isSupport(File file){
		return file.isFile();
	}
	public String[] getExtentions(){
		return new String[]{"zip"};
	}
	public String getDescription(){
		return "ZIPt@C (.zip)";
	}
	public int getFileSelectionMode(){
		return javax.swing.JFileChooser.FILES_ONLY;
	}
}