//Written by JavaMaker
//JPGDialog.java
package yoshi.imageio.filedialog;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class JPGDialog extends JDialog
	implements ActionListener, ChangeListener
{
	private JButton ok,cancel;
	private JSlider bar;
	private JLabel label;
	private boolean isWrite = false;
	
	public JPGDialog(Frame parent){
		super(parent,true);
		initComponents();
		setLocationRelativeTo(parent);
	}
	public boolean isWrite(){
		return isWrite;
	}
	public float getQuality(){
		return (float)bar.getValue()/100.0f;
	}
	
	public void actionPerformed(ActionEvent e) {
		//JButton,JTextField,JMenuItemȂǂɊւ鏈Ă
		Object obj = e.getSource();
		if(obj == ok){
			isWrite = true;
			setVisible(false);
		}else if(obj == cancel){
			isWrite = false;
			setVisible(false);
		}
	}
	public void stateChanged(ChangeEvent e){
		if(label != null){
			label.setText(String.valueOf(bar.getValue()));
		}
	}

	private void initComponents() {
		//TODO: ɏ̏Ă

		setTitle("Jpeg̃IvVݒ");
		//傫ݒ肵܂
		setSize(210,180);
		getContentPane().setLayout(new BorderLayout(2,2));
		
		getContentPane().add(new JLabel("Jpeg̃IvVݒ",JLabel.CENTER),BorderLayout.NORTH);
		getContentPane().add(createSouth(),BorderLayout.SOUTH);
		getContentPane().add(createCenter(),BorderLayout.CENTER);
		
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				setVisible(false);
			}
		});
	}
	private JPanel createCenter(){
		JPanel p = new JPanel();
		p.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"摜̕i"));
		p.setLayout(new BoxLayout(p,BoxLayout.Y_AXIS));
		label = new JLabel("100",SwingConstants.CENTER);
		p.add(label);
		bar = new JSlider(0,100,100);
		bar.setMajorTickSpacing(20);
		bar.setPaintTicks(true);
	//	bar.setSnapToTicks(true);
		bar.setPaintLabels(true);
		bar.addChangeListener(this);
		p.add(bar);
		
		return p;
	}
	private JPanel createSouth(){
		JPanel p = new JPanel();
		p.setLayout(new GridLayout(1,2));
		
		ok = new JButton("");
		ok.addActionListener(this);
		p.add(ok);
		
		cancel = new JButton("");
		cancel.addActionListener(this);
		p.add(cancel);
		
		return p;
	}
}
