package yoshi.layer;

import java.awt.*;
import java.awt.image.BufferedImage;
import javax.swing.Icon;
import java.util.Random;

public abstract class Layer extends Rectangle
{
	//g̐F̃e[u
	private static final Color[] colorTable = {Color.red, Color.green, Color.blue, Color.yellow
		, Color.magenta, Color.orange, Color.pink, Color.white};
	private static Random random = new Random();
	
	//O
	private String name = "C[";
	//I̗L
	private boolean isImageSelected = false;
	//g̐F
	private Color clrBorder = Color.white;

	/**
	* RXgN^
	*/
	public Layer(String name){
		this();
		this.name = name;
	}
	public Layer(){
		clrBorder = colorTable[random.nextInt(colorTable.length)];
	}
	/**
	* ̃C[`܂
	*/
	public void display(Graphics g, int ox, int oy, Component c){
		drawImage(g, ox, oy, c);
		if(isImageSelected){
			g.setColor(clrBorder);
			g.drawRect(x,y,width,height);
		}
	}
	/**
	* I̗Lݒ肵܂
	*/
	public void setImageSelected(boolean isImageSelected){
		this.isImageSelected = isImageSelected;
	}
	/**
	* I̗LԂ܂
	*/
	public boolean isImageSelected(){
		return isImageSelected;
	}
	/**
	* g̐Fݒ肵܂
	*/
	public void setBorderColor(Color clrBorder){
		this.clrBorder = clrBorder;
	}
	/**
	* g̐FԂ܂
	*/
	public Color getBorderColor(){
		return clrBorder;
	}
	/**
	* O擾܂
	*/
	public String getName(){
		return name;
	}
	/**
	* Oݒ肵܂
	*/
	public void setName(String name){
		this.name = name;
	}
	/**
	* 摜擾܂
	*/
	public abstract BufferedImage getImage();
	/**
	* ACRԂ܂
	*/
	public abstract Icon getIcon();
	/**
	* 摜ۑpɉ摜̂ݏo܂
	*/
	public abstract void drawImage(Graphics g, int ox, int oy, Component c);
	/**
	* ҏWʂo܂
	*/
	public abstract void showEditDialog(Frame parent);
	/**
	* UIXV܂
	*/
	public abstract void updateUI();
}
