//Written by JavaMaker
//LayerList.java
/**
* C[̓Ɠ`NXł
*/
package yoshi.layer;

import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;

public class LayerList

{
	//TODO: ̈ʒuɕϐ̐錾Ă
	private Layer[] layers;
	private int width,height;
	
	/**
	* RXgN^
	*/
	public LayerList() {
		layers = new Layer[0];
	}
	/**
	* 摜\܂
	*/
	public void display(Graphics g,int x, int y, Component c){
		if(layers != null && layers.length > 0){
			for(int i=layers.length-1;i>=0;i--){
				layers[i].display(g, 0, 0, c);
			}
		}
	}
	/**
	* 摜ۑpɉ摜̂ݏo܂
	*/
	public void drawImage(Graphics g, int ox, int oy, Component c){
		if(layers != null && layers.length > 0){
			for(int i=layers.length-1;i>=0;i--){
				layers[i].drawImage(g, ox, oy, c);
			}
		}
	}
	/**
	* C[VKǉ܂B
	*/
	public void addLayer(Layer layer, Component parent){
		if(layer != null){
			String name = (String)JOptionPane.showInputDialog(parent, "C[̖O͂Ă"
				,"C[̖O", JOptionPane.INFORMATION_MESSAGE, layer.getIcon(), null, "C["+layers.length);

			if(name != null && name.length() > 0){
				layer.setName(name);
				Layer[] newLayers = new Layer[layers.length + 1];
				System.arraycopy(layers, 0, newLayers, 0, layers.length);
				newLayers[layers.length] = layer;
				layers = newLayers;
				checkSize();
			}
		}
	}
	/**
	* 摜폜܂B
	*/
	public void deleteLayer(int index, Component parent){
		int result = JOptionPane.showConfirmDialog( parent, layers[index].getName()+"̍폜܂B낵łH"
			, layers[index].getName()+"̍폜", JOptionPane.YES_NO_OPTION
			, JOptionPane.WARNING_MESSAGE, layers[index].getIcon() );
		
		if(result == JOptionPane.YES_OPTION){
			Layer[] newLayers = new Layer[layers.length -1];
			System.arraycopy(layers,0,newLayers,0,index);
			System.arraycopy(layers,index+1,newLayers,index,newLayers.length-index);
			layers = newLayers;
			checkSize();
		}
	}
	/**
	* \ppl̕擾܂
	*/
	public int getWidth(){
		return width;
	}
	/**
	* \ppl̍擾܂
	*/
	public int getHeight(){
		return height;
	}
	/**
	* 傫ύXʒm܂B
	*/
	public void checkSize(){
		width = 0;
		height = 0;
		for(int i=0;i<layers.length;i++){
			int tempW = layers[i].x + layers[i].width;
			int tempH = layers[i].y + layers[i].height;
			if(tempW > width){
				width = tempW;
			}
			if(tempH > height){
				height = tempH;
			}
		}
	}
	/**
	* C[̐擾܂
	*/
	public int size(){
		return layers.length;
	}
	/**
	* C[擾܂
	*/
	public Layer getLayer(int index){
		return layers[index];
	}
	public Layer[] getLayers(){
		return layers;
	}
	/**
	* w肵CfbNXŏɑIĂ郌C[T܂B
	*/
	public int getSelectedIndex(int startIndex){
		for(int i=startIndex;i<layers.length;i++){
			if(layers[i].isImageSelected()){
				return i;
			}
		}
		return -1;
	}
	/**
	* I𒆂̃C[̐擾܂
	*/
	public int getSelectedNumber(){
		int number = 0;
		for(int i=0;i<layers.length;i++){
			if(layers[i].isImageSelected()){
				number++;
			}
		}
		return number;
	}
	/**
	* ORŽʂ擾܂
	*/
	public Rectangle getUnionRectangle(){
		if(layers.length > 0){
			Rectangle max = new Rectangle(layers[0]);
			for(int i=1;i<layers.length;i++){
				max = max.union(layers[i]);
			}
			return max;
		}else{
			return new Rectangle();
		}
	}
	/**
	* ANDŽʂ擾܂
	*/
	public Rectangle getIntersectionRectangle(){
		if(layers.length > 0){
			Rectangle min = new Rectangle(layers[0]);
			for(int i=1;i<layers.length;i++){
				min = min.intersection(layers[i]);
			}
			return min;
		}else{
			return new Rectangle();
		}
	}
	/**
	* 摜̃C[w肵Ԃɂ܂B
	*/
	public void setLayerLevel(int[] level){
		if(layers.length == level.length){
			Layer[] newLayers = new Layer[layers.length];
			for(int i=0;i<layers.length;i++){
				newLayers[i] = layers[level[i]];
			}
			layers = newLayers;
		}
	}
	/**
	* 摜ł낦܂
	*/
	public void dressTop(){
		Rectangle max = getUnionRectangle();
		for(int i=0;i<layers.length;i++){
			layers[i].y = max.y;
		}
	}
	/**
	* 摜ł낦܂
	*/
	public void dressBottom(){
		Rectangle max = getUnionRectangle();
		for(int i=0;i<layers.length;i++){
			layers[i].y = max.y + (max.height - layers[i].height);
		}
	}
	/**
	* 摜ł낦܂
	*/
	public void dressLeft(){
		Rectangle max = getUnionRectangle();
		for(int i=0;i<layers.length;i++){
			layers[i].x = max.x;
		}
	}
	/**
	* 摜Eł낦܂
	*/
	public void dressRight(){
		Rectangle max = getUnionRectangle();
		for(int i=0;i<layers.length;i++){
			layers[i].x = max.x + (max.width - layers[i].width);
		}
	}
	/**
	* }EX̃NbN̓`܂
	*/
	public void mouseClicked(Point newPoint, Point lastPoint, boolean modifyCTRL) {
		if(modifyCTRL){  //I
			for(int i=0;i<layers.length;i++){
				if(!layers[i].isImageSelected() && layers[i].contains(newPoint.x, newPoint.y)){
					layers[i].setImageSelected(true);
					break;
				}
			}
		}else{ //PI
			int number = getSelectedNumber();
			if(number > 1){ //xNAs
				for(int i=0;i<layers.length;i++){
					if(layers[i].isImageSelected()){
						layers[i].setImageSelected(false);
					}
				}
			}else if(number == 1){ //̊ŶI
				int index = getSelectedIndex(0);
				layers[index].setImageSelected(false);
				//̂̂艺̂̂ŊŶT
				index = getContainsIndex(newPoint.x, newPoint.y, index+1);
				if(index < 0){ //ȂƂŏT
					index = getContainsIndex(newPoint.x, newPoint.y, 0);
				}
				//I
				if(index >= 0){
					layers[index].setImageSelected(true);
				}
			}else{ //number == 0̂Ƃ
				int index = getContainsIndex(newPoint.x, newPoint.y, 0);
				//I
				if(index >= 0){
					layers[index].setImageSelected(true);
				}
			}
		}
	}
	private int getContainsIndex(int x, int y, int startIndex){
		for(int i=startIndex;i<layers.length;i++){
			if(layers[i].contains(x ,y)){
				return i;
			}
		}
		return -1;
	}
	/**
	* }EX̉Ƃ̓`܂
	*/
	public void mousePressed(Point newPoint, Point lastPoint, boolean modifyCTRL) {
		//`Ȃ
	}
	/**
	* }EX̗Ƃ̓`܂
	*/
	public void mouseReleased(Point newPoint, Point lastPoint, boolean modifyCTRL) {
		for(int i=0;i<layers.length;i++){
			if(layers[i].isImageSelected()){//Iꂽׂ̂Ĉړ
				layers[i].translate(newPoint.x-lastPoint.x,newPoint.y-lastPoint.y);
			}
		}
		checkSize();
	}
	/**
	* }EX̃hbO̓`܂
	*/
	public void mouseDragged(Point newPoint, Point lastPoint, boolean modifyCTRL) {
		for(int i=0;i<layers.length;i++){
			if(layers[i].isImageSelected()){//Iꂽׂ̂Ĉړ
				layers[i].translate(newPoint.x-lastPoint.x,newPoint.y-lastPoint.y);
			}
		}
	}
	/**
	* UI̍XV܂B
	*/
	public void updateUI(){
		for(int i=0;i<layers.length;i++){
			layers[i].updateUI();
		}
	}
}
