//Written by JavaMaker
//ImageLayer.java
package yoshi.layer.image;

import java.awt.*;
import java.awt.image.BufferedImage;
import javax.swing.SwingUtilities;
import javax.swing.Icon;

import yoshi.editmenu.ImageCache;
import yoshi.layer.Layer;

public class ImageLayer extends Layer
{
	//ҏW
	private static EditDialog edit;
	private static boolean isUpdate = false;
	
	//\摜
	private BufferedImage img;
	//k摜
	private Icon icon;
	//LbV
	private ImageCache cache;
	
	/**
	* RXgN^
	*/
	public ImageLayer(BufferedImage img, Icon icon, String name) {
		super(name);
		setImage(img,icon);
		cache = new ImageCache(img, 3);
	}
	public ImageLayer(BufferedImage img, Icon icon) {
		super();
		setImage(img,icon);
		cache = new ImageCache(img, 3);
	}
	//------------ Layer̎ -------------//
	/**
	* 摜ۑpɉ摜̂ݏo܂
	*/
	public void drawImage(Graphics g, int ox, int oy, Component c){
		if(img != null){
			g.drawImage(img, ox + x, oy + y, c);
		}
	}
	/**
	* ACRԂ܂
	*/
	public Icon getIcon(){
		return icon;
	}
	/**
	* 摜擾܂
	*/
	public BufferedImage getImage(){
		return img;
	}
	/**
	* ҏWʂo܂
	*/
	public void showEditDialog(Frame parent){
		if(edit == null){
			edit = new EditDialog(parent);
		}else if(isUpdate){
			SwingUtilities.updateComponentTreeUI(edit);
		}
		
		edit.setImageLayer(this);
		edit.setVisible(true);
	}
	/**
	* UIXV܂
	*/
	public void updateUI(){
		isUpdate = true;
	}
	//-------- Layer̎ ܂ ----------//
	
	/**
	* 摜w肵܂
	*/
	protected void setImage(BufferedImage img, Icon icon){
		this.img = img;
		this.width = img.getWidth();
		this.height = img.getHeight();
		this.icon = icon;
	}
	/**
	* LbV擾܂
	*/
	protected ImageCache getImageCache(){
		return cache;
	}
}
